//#include <Carbon.h>
#include <gl.h>
#include <string.h>
#include "CFM_Bridge.h"
#include "CFM_CGL_Bridge.h"

#pragma export on

// function pointer declarations
// Note: One could use the exact entry point names but it would have mulitply defined symbols in Mac OS X 10.2 and later
//       pfXXX is chosen to represent 'pointer to function'
/* Pixel format functions */
CGLChoosePixelFormatPtr pfCGLChoosePixelFormat = NULL;
CGLDestroyPixelFormatPtr pfCGLDestroyPixelFormat = NULL;
CGLDescribePixelFormatPtr pfCGLDescribePixelFormat = NULL;
/* Renderer information functions */
CGLQueryRendererInfoPtr pfCGLQueryRendererInfo = NULL;
CGLDestroyRendererInfoPtr pfCGLDestroyRendererInfo = NULL;
CGLDescribeRendererPtr pfCGLDescribeRenderer = NULL;
/* Context functions */
CGLCreateContextPtr pfCGLCreateContext = NULL;
CGLDestroyContextPtr pfCGLDestroyContext = NULL;
CGLCopyContextPtr pfCGLCopyContext = NULL;
CGLSetCurrentContextPtr pfCGLSetCurrentContext = NULL;
CGLGetCurrentContextPtr pfCGLGetCurrentContext = NULL;
/* PBuffer functions */
CGLCreatePBufferPtr pfCGLCreatePBuffer = NULL;
CGLDestroyPBufferPtr pfCGLDestroyPBuffer = NULL;
CGLDescribePBufferPtr pfCGLDescribePBuffer = NULL;
CGLTexImagePBufferPtr pfCGLTexImagePBuffer = NULL;
/* Drawable Functions */
CGLSetOffScreenPtr pfCGLSetOffScreen = NULL;
CGLGetOffScreenPtr pfCGLGetOffScreen = NULL;
CGLSetFullScreenPtr pfCGLSetFullScreen = NULL;
CGLSetPBufferPtr pfCGLSetPBuffer = NULL;
CGLGetPBufferPtr pfCGLGetPBuffer = NULL;
CGLClearDrawablePtr pfCGLClearDrawable = NULL;
CGLFlushDrawablePtr pfCGLFlushDrawable = NULL;
/* Per context enables and parameters */
CGLEnablePtr pfCGLEnable = NULL;
CGLDisablePtr pfCGLDisable = NULL;
CGLIsEnabledPtr pfCGLIsEnabled = NULL;
CGLSetParameterPtr pfCGLSetParameter = NULL;
CGLGetParameterPtr pfCGLGetParameter = NULL;
/* Virtual screen functions */
CGLSetVirtualScreenPtr pfCGLSetVirtualScreen = NULL;
CGLGetVirtualScreenPtr pfCGLGetVirtualScreen = NULL;
/* Global library options */
CGLSetOptionPtr pfCGLSetOption = NULL;
CGLGetOptionPtr pfCGLGetOption = NULL;
/* Locking functions */
CGLLockContextPtr pfCGLLockContext = NULL;
CGLUnlockContextPtr pfCGLUnlockContext = NULL;
/* Version numbers */
CGLGetVersionPtr pfCGLGetVersion = NULL;
/* Convert an error code to a string */
CGLErrorStringPtr pfCGLErrorString = NULL;

#pragma export off


/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
// Specific missing entry point support code

CFBundleRef gBundleRefCGL = NULL;

OSStatus InitMissingCGLEntryPoints (void);
void DeallocMissingCGLEntryPoints (void);

/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
OSStatus InitMissingCGLEntryPoints (void)
{
	OSStatus err;
	err = initEntryPoints (CFSTR("OpenGL.framework"), &gBundleRefCGL);	// init bundle
	if (noErr == err) {
		/* Pixel format functions */
		pfCGLChoosePixelFormat = (CGLChoosePixelFormatPtr) getProcAddress (CFSTR("CGLChoosePixelFormat"), &gBundleRefCGL);
		pfCGLDestroyPixelFormat = (CGLDestroyPixelFormatPtr) getProcAddress (CFSTR("CGLDestroyPixelFormat"), &gBundleRefCGL);
		pfCGLDescribePixelFormat = (CGLDescribePixelFormatPtr) getProcAddress (CFSTR("CGLDescribePixelFormat"), &gBundleRefCGL);
		/* Renderer information functions */
		pfCGLQueryRendererInfo = (CGLQueryRendererInfoPtr) getProcAddress (CFSTR("CGLQueryRendererInfo"), &gBundleRefCGL);
		pfCGLDestroyRendererInfo = (CGLDestroyRendererInfoPtr) getProcAddress (CFSTR("CGLDestroyRendererInfo"), &gBundleRefCGL);
		pfCGLDescribeRenderer = (CGLDescribeRendererPtr) getProcAddress (CFSTR("CGLDescribeRenderer"), &gBundleRefCGL);
		/* Context functions */
		pfCGLCreateContext = (CGLCreateContextPtr) getProcAddress (CFSTR("CGLCreateContext"), &gBundleRefCGL);
		pfCGLDestroyContext = (CGLDestroyContextPtr) getProcAddress (CFSTR("CGLDestroyContext"), &gBundleRefCGL);
		pfCGLCopyContext = (CGLCopyContextPtr) getProcAddress (CFSTR("CGLCopyContext"), &gBundleRefCGL);
		pfCGLSetCurrentContext = (CGLSetCurrentContextPtr) getProcAddress (CFSTR("CGLSetCurrentContext"), &gBundleRefCGL);
		pfCGLGetCurrentContext = (CGLGetCurrentContextPtr) getProcAddress (CFSTR("CGLGetCurrentContext"), &gBundleRefCGL);
		/* PBuffer functions */
		pfCGLCreatePBuffer = (CGLCreatePBufferPtr) getProcAddress (CFSTR("CGLCreatePBuffer"), &gBundleRefCGL);
		pfCGLDestroyPBuffer = (CGLDestroyPBufferPtr) getProcAddress (CFSTR("CGLDestroyPBuffer"), &gBundleRefCGL);
		pfCGLDescribePBuffer = (CGLDescribePBufferPtr) getProcAddress (CFSTR("CGLDescribePBuffer"), &gBundleRefCGL);
		pfCGLTexImagePBuffer = (CGLTexImagePBufferPtr) getProcAddress (CFSTR("CGLTexImagePBuffer"), &gBundleRefCGL);
		/* Drawable Functions */
		pfCGLSetOffScreen = (CGLSetOffScreenPtr) getProcAddress (CFSTR("CGLSetOffScreen"), &gBundleRefCGL);
		pfCGLGetOffScreen = (CGLGetOffScreenPtr) getProcAddress (CFSTR("CGLGetOffScreen"), &gBundleRefCGL);
		pfCGLSetFullScreen = (CGLSetFullScreenPtr) getProcAddress (CFSTR("CGLSetFullScreen"), &gBundleRefCGL);
		pfCGLSetPBuffer = (CGLSetPBufferPtr) getProcAddress (CFSTR("CGLSetPBuffer"), &gBundleRefCGL);
		pfCGLGetPBuffer = (CGLGetPBufferPtr) getProcAddress (CFSTR("CGLGetPBuffer"), &gBundleRefCGL);
		pfCGLClearDrawable = (CGLClearDrawablePtr) getProcAddress (CFSTR("CGLClearDrawable"), &gBundleRefCGL);
		pfCGLFlushDrawable = (CGLFlushDrawablePtr) getProcAddress (CFSTR("CGLFlushDrawable"), &gBundleRefCGL);
		/* Per context enables and parameters */
		pfCGLEnable = (CGLEnablePtr) getProcAddress (CFSTR("CGLEnable"), &gBundleRefCGL);
		pfCGLDisable = (CGLDisablePtr) getProcAddress (CFSTR("CGLDisable"), &gBundleRefCGL);
		pfCGLIsEnabled = (CGLIsEnabledPtr) getProcAddress (CFSTR("CGLIsEnabled"), &gBundleRefCGL);
		pfCGLSetParameter = (CGLSetParameterPtr) getProcAddress (CFSTR("CGLSetParameter"), &gBundleRefCGL);
		pfCGLGetParameter = (CGLGetParameterPtr) getProcAddress (CFSTR("CGLGetParameter"), &gBundleRefCGL);
		/* Virtual screen functions */
		pfCGLSetVirtualScreen = (CGLSetVirtualScreenPtr) getProcAddress (CFSTR("CGLSetVirtualScreen"), &gBundleRefCGL);
		pfCGLGetVirtualScreen = (CGLGetVirtualScreenPtr) getProcAddress (CFSTR("CGLGetVirtualScreen"), &gBundleRefCGL);
		/* Global library options */
		pfCGLSetOption = (CGLSetOptionPtr) getProcAddress (CFSTR("CGLSetOption"), &gBundleRefCGL);
		pfCGLGetOption = (CGLGetOptionPtr) getProcAddress (CFSTR("CGLGetOption"), &gBundleRefCGL);
		/* Locking functions */
		pfCGLLockContext = (CGLLockContextPtr) getProcAddress (CFSTR("CGLLockContext"), &gBundleRefCGL);
		pfCGLUnlockContext = (CGLUnlockContextPtr) getProcAddress (CFSTR("CGLUnlockContext"), &gBundleRefCGL);
		/* Version numbers */
		pfCGLGetVersion = (CGLGetVersionPtr) getProcAddress (CFSTR("CGLGetVersion"), &gBundleRefCGL);
		/* Convert an error code to a string */
		pfCGLErrorString = (CGLErrorStringPtr) getProcAddress (CFSTR("CGLErrorString"), &gBundleRefCGL);
	}
	return err;
}

// -------------------------

void DeallocMissingCGLEntryPoints (void)
{
	/* Pixel format functions */
	pfCGLChoosePixelFormat = NULL;
	pfCGLDestroyPixelFormat = NULL;
	pfCGLDescribePixelFormat = NULL;
	/* Renderer information functions */
	pfCGLQueryRendererInfo = NULL;
	pfCGLDestroyRendererInfo = NULL;
	pfCGLDescribeRenderer = NULL;
	/* Context functions */
	pfCGLCreateContext = NULL;
	pfCGLDestroyContext = NULL;
	pfCGLCopyContext = NULL;
	pfCGLSetCurrentContext = NULL;
	pfCGLGetCurrentContext = NULL;
	/* PBuffer functions */
	pfCGLCreatePBuffer = NULL;
	pfCGLDestroyPBuffer = NULL;
	pfCGLDescribePBuffer = NULL;
	pfCGLTexImagePBuffer = NULL;
	/* Drawable Functions */
	pfCGLSetOffScreen = NULL;
	pfCGLGetOffScreen = NULL;
	pfCGLSetFullScreen = NULL;
	pfCGLSetPBuffer = NULL;
	pfCGLGetPBuffer = NULL;
	pfCGLClearDrawable = NULL;
	pfCGLFlushDrawable = NULL;
	/* Per context enables and parameters */
	pfCGLEnable = NULL;
	pfCGLDisable = NULL;
	pfCGLIsEnabled = NULL;
	pfCGLSetParameter = NULL;
	pfCGLGetParameter = NULL;
	/* Virtual screen functions */
	pfCGLSetVirtualScreen = NULL;
	pfCGLGetVirtualScreen = NULL;
	/* Global library options */
	pfCGLSetOption = NULL;
	pfCGLGetOption = NULL;
	/* Locking functions */
	pfCGLLockContext = NULL;
	pfCGLUnlockContext = NULL;
	/* Version numbers */
	pfCGLGetVersion = NULL;
	/* Convert an error code to a string */
	pfCGLErrorString = NULL;

	deallocEntryPoints (&gBundleRefCGL); // dump bundle
}
